<%@ page language="java" pageEncoding="UTF-8" %>
<%@ include file="/WEB-INF/view/Include.jsp" %>

<%-- @see org.unitedfront2.web.controller.account.LoginFormController --%>
<tiles:importAttribute name="username" ignore="true"/>
<tiles:importAttribute name="authenticationException" ignore="true"/>
<tiles:importAttribute name="userStatus" ignore="true"/>

<div class="widget">
  <h3><spring:message code="account.LoginForm.title"/></h3>
  <div class="padding">
    <c:if test="${not empty authenticationException}"><div class="errors"><spring:message code="account.LoginForm.error"/><c:if test="${userStatus == 'LOCKED'}"><spring:message code="account.validation.locked"/></c:if></div></c:if>
    <form action="<c:url value="/account/login.html"/>" method="post" id="loginForm">
      <div class="element"><spring:message code="mailAddr"/>: <span id="mailAddr.errors" class="errors"></span><br/><input type="text" name="j_username" value="<c:if test="${not empty username}"><c:out value="${username}"/></c:if>" id="loginForm.mailAddr" size="18"/></div>
      <div class="element"><spring:message code="password"/>: <span id="password.errors" class="errors"></span><br/><input type="password" name="j_password" value="" size="18"/></div>
      <uf2:pc>
        <div class="element"><label for="remember"><input type="checkbox" name="remember" id="remember"/> <spring:message code="account.LoginForm.rememberme"/></label></div>
      </uf2:pc>
      <div class="element"><input type="submit" value="<spring:message code="login"/>" class="button" onclick="this.disabled='disabled';this.form.submit();"/></div>
    </form>
    <uf2:pc>
      <div><a href="<c:url value="/account/passwordReissue.html"/>"><spring:message code="account.PasswordReissue.link"/></a></div>
    </uf2:pc>
  </div>
</div>
<security:authorize ifNotGranted="ROLE_USER,ROLE_ADMIN">
<div class="margin smaller">
  <h3><spring:message code="Registration.title"/></h3>
  <div><a href="<c:url value="/registration.html"/>"><spring:message code="Registration.link"/></a></div>
</div>
</security:authorize>
